#include	"mview.h"
#include	<string.h>

extern int	SendCheck( char* );
extern int	MailExec( WindowID, EventInfo* );

static int	DirExec( WindowID, EventInfo* );


static int
DirExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[DIRMAX+1], *dp= dbuf;

	switch( info->option ){
	case EventOpen:
		if( DIRGET() ){;	/* xZbg */
	    		WindowSetEventAttr( wp, EventAttrDefault );
			Dwp= wp;
    	}else {
			Dwp= NULL;
		}
		return TRUE;

	case EventRedraw:
	{
		int	i, attr;
		DrawSetClear( dp++, 1 );
		for( i= 0; i < DirNow; i++ ){
			attr= (i != DirPos)? AttrDefault:(AttrDefault ^ 8);
			if( DirOptName[i][0] ){
				DrawSetSymbol( dp++, 0, i * 16, DirOptName[ i ], attr, 16 );
			}else {
				DrawSetSymbol( dp++, 0, i * 16, DirName[ i ], attr, 16 );
			}
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;
	}

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:{
		int	y= info->y / 16;

		if( !info->LeftON || y > DirNow )	return TRUE;
		if( MailNow )	SaveInf ();	/* ǏȂǂ̕ۑ */
		if( DirOptName[DirPos][0] ){
			DrawSetSymbol( dp++, 0, DirPos * 16, DirOptName[DirPos], AttrDefault, 16 );
		}else {
			DrawSetSymbol( dp++, 0, DirPos * 16, DirName[DirPos], AttrDefault, 16 );
		}
		if( DirOptName[y][0] ){
			DrawSetSymbol( dp++, 0, y * 16, DirOptName[y], AttrDefault ^ 8, 16 );
		}else {
			DrawSetSymbol( dp++, 0, y * 16, DirName[y], AttrDefault ^ 8, 16 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		DirPos= y; 

		SendFlag= SendCheck( DirName[DirPos] );

		if( !strcmpi( DirName[DirPos], "SEND" ) ){
			SendFlag = 2;	/* Send̂ */
		}
		TrashFlag= ( !strcmpi( DirName[DirPos], "TRASH" ) )? 1:0;

		strcpy( CDir, EnvMailbox );
		strcat( CDir, DirName[DirPos] );
		strcat( CDir, "\\" );
		WindowClose( Mwp );
		FILEGET( 0 );
		Mwp= WindowScrollOpen( 120, 0, 392, 240, Bwp, 392,(MailNow*12<=236)?236:MailNow*12,
						DirectionY, 16, 12, MailExec );
	}
		return TRUE;
	case EventKey:
/*		MainCont( wp, info );*/
		return TRUE;

	}
	return FALSE;
}


int
MainExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[1];

	switch( info->option ){
	case EventOpen:
		Bwp= wp;
    	WindowSetEventAttr( wp, EventAttrDefault );
		strcpy( CDir, EnvMailbox );
		WindowScrollOpen( 0, 0, 120, 240, wp, 120,(DirNow*16<=236)?236:DirNow*16,
					DirectionY, 16, 16, DirExec );
		if( Dwp ){
			strcat( CDir, DirName[DirPos] );
			strcat( CDir, "\\" );
			FILEGET( 0 );
			Mwp= WindowScrollOpen( 120, 0, 392, 240, wp, 392,
					(MailNow*12 <= 236)? 236 : (MailNow * 12),
					DirectionY, 16, 12, MailExec );
			WindowRedraw( wp );
		}else {
			WindowConnectionClose();
		}
		return TRUE;

	case EventRedraw:
		DrawSetClear( dbuf, 1 );
		WindowDraw( wp, dbuf, 1 );
		if( Dwp )	WindowRedraw( Dwp );
		if( Mwp )	WindowRedraw( Mwp );
		return TRUE;

	case EventClose:
		WindowClose( wp );
		quitop();
		return TRUE;

	case EventMouseSwitch:
	case EventKey:
		if( info->y <= 240 ){
			if( info->x <= 120 ){
				return WindowSendEvent( Dwp, info );
			}else {
				info->x-= 120;
				return WindowSendEvent( Mwp, info );
			}
		}
		return FALSE;

	case EventIconify:
		IconEnt( wp, "mview", AttrDefault|AttrHighLight, 16 );
		return TRUE;
	}
	return FALSE;
}

void
mesprint( message )
char	*message;
{
	DrawBuf	dbuf[2];

	if( !Bwp )	return;
	
	DrawSetLine( dbuf, 0, 242,  511, 254, 1, OptionFill );
	DrawSetSymbol( dbuf + 1, 0, 242, message, AttrDefault, 12 );
	WindowDraw( Bwp, dbuf, 2 );
}
