#include	"mview.h"
#include	"mime.h"
#include	<winop.h>
#include	<string.h>

int	WindowHeapSize= 8 * 1024;

static int GetEnvRc();
static char *GetKeyword( char*, char* );
static void	SmailInit();
static void	AddressInit();

/* ^ꂽ̒ΏەԂ */
char
*GetKeyword( Str, Temp )
char	*Str;
char	*Temp;
{
	char *ret= Str;
	int	len;

	len= strlen( Temp );
	
	if( strncmp( ret, Temp, len ) )	return NULL;	/* s̏ꍇ */

	ret+= len;						/* Ȃ܂̕Q */
	for( ; *ret == ' ' || *ret == '\t'; ret++ );	/* ^uȂǂƂ΂ */

	len= strlen( ret );
	if( ret[len - 1] == '\n' )	ret[len - 1]= NULL;	/* Ō̉sE */

	return ret;
}


/* ǂݏo */
int
GetEnvRc()
{
	char	Temp[256], *TempP;
	FILE	*fp;
	char	MailboxFlag= 0, MviewerFlag= 0, MedFlag= 0;	/* K{ݒtO */

	ConsoleOpen();
	if ( !( TempP= KoWindowGetEnv( "MVIEWRC" ) ) ) {
		ConsolePrint( "mview : ϐMVIEWRCZbgĂ\n" );
		return FALSE;
	}
	strcpy( Temp, TempP );

	if ( !(fp= fopen( Temp, "rt" ) ) ) {
		ConsolePrintf( "mview : t@C%s܂B\n", Temp );
		return FALSE;
	}

	/* t@Cǂœe */
	while( fgets( Temp, 256, fp ) ){
										/* ߂Ƌs͖ */
		if( Temp[0] == '#' || Temp[0] == '\n' ) continue;

		if( TempP = GetKeyword( Temp, "mailbox" ) ){
			strcpy( EnvMailbox, TempP );
			strcat( EnvMailbox, "\\" );
			MailboxFlag= 1;
			continue;
			
		}else if( TempP= GetKeyword( Temp, "koview" ) ){
			char	*tmp;
			for( tmp= EnvMviewer; *TempP > ' '; *tmp++= *TempP++ );
			*tmp= NULL;
			for( ; *TempP && *TempP <= ' '; TempP++ );
			for( tmp= viewopt; *TempP > ' '; *tmp++= *TempP++ );
			*tmp++= ' ';
			*tmp= NULL;
			MviewerFlag= 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "koed" ) ){
			char	*tmp;
			for( tmp= EnvMed; *TempP > ' '; *tmp++= *TempP++ );
			*tmp= NULL;
			for( ; *TempP && *TempP <= ' '; TempP++ );
			for( tmp= edopt; *TempP > ' '; *tmp++= *TempP++ );
			*tmp++= ' ';
			*tmp= NULL;
			MedFlag= 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "option name" ) ){
			if( !SmailNow ) SmailNow= 1;
			strcpy( SmailName[SmailNow], TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "smail option" ) ){
			if( !SmailNow ) SmailNow= 1;
			strcpy( SmailOption[SmailNow++], TempP );
			continue;	
	
		}else if( TempP= GetKeyword( Temp, "signature name" ) ){
			strcpy( SignatureName[SignatureNow], TempP );
			continue;
			
		}else if( TempP= GetKeyword( Temp, "signature file" ) ){
			strcpy( SignatureFile[SignatureNow++], TempP );
			continue;
			
		}else if( TempP= GetKeyword( Temp, "mimebox" ) ){
			strcpy( EnvMimebox, TempP );
			strcat( EnvMimebox, "\\" );
			MimeFlag = 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "wordrap" ) ){
			strcpy( EnvWordrap, TempP );
			strcat( EnvWordrap, "\\" );
			WordrapFlag= 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "firstseek" ) ){
			if( !strcmpi( TempP, "start" ) )	SeekFlag = 0;
			if( !strcmpi( TempP, "end" ) )	SeekFlag = 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "quotation mark" ) ){
			strcpy( Qmark, TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "default subject" ) ){
			strcpy( DefSubject, TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "sentbox" ) ){
			strcpy( EnvSentbox, TempP );
			SentboxFlag = 1;
		}
	}
	if( !(MailboxFlag && MviewerFlag && MedFlag ) ){
		ConsolePrint( "mview : t@CɕK{ڂݒ肳Ă܂\n" );
		fclose( fp );
		return FALSE;
	}
	fclose( fp );
	return TRUE;
}

/* smail֌W̏ */
void
SmailInit()
{
	int	i;

	SmailNow= 0;
	SignatureNow= 0;
	strcpy( SmailName[0], "ʏ푗M" );
	SmailOption[0][0]= NULL;
	strcpy( SignatureName[0], "gȂ" );
	for( i= 1; i < 16; i++ ){
		sprintf( SmailName[i], "IvV%d", i );
		sprintf( SignatureName[i], "%d", i );
		SmailOption[i][0]= NULL;
	}
}

/* AhXǂݍ */
void
AddressInit()
{
	char	Temp[256], *TempP;
	FILE	*fp;

	strcpy( Temp, EnvMailbox );
	strcat( Temp, "ADRESS.TXT" );
	AdressNow= 0;
	if( fp= fopen( Temp, "rt" ) ){
		while( fgets( Temp, 256, fp ) ){
			TempP= memccpy( Adress[AdressNow]. name, Temp, '\t', STR_MAX );
			*(TempP - 1)= 0;		/* ܂O擾 */
			TempP= strchr( Temp, '\t' );
			for( ; *TempP == '\t'; TempP++ );	/* AhX̓o */
			strcpy( Adress[AdressNow].adress, TempP );
			Adress[AdressNow].adress[strlen(Adress[AdressNow].adress)-1]= NULL;
												/* sR[h΂ */
			AdressNow++;						/* łP擾 */
		}
		fclose ( fp );
	}
}

void
WindowMain( argc, argv )
int argc;
char *argv[];
{
	int x= 100, y= 120;

	/* tO֌W̏ */
	MimeFlag= 0;
	WordrapFlag= 0;
	SeekFlag= 0;
	SentboxFlag= 0;
	strcpy( Qmark, "> " );
	strcpy( DefSubject, "*NoTitle*" );

	SmailInit ();

	if( !GetEnvRc() ){
		WindowConnectionClose();
		return;
	}
	AddressInit();

	Dir = 0;

	AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	WindowTitleOpen( x, y, 512, 256, NULL, "MVIEW", Push|Icon|Close, MainExec );
}

